import { SignalEmitter } from '../emitter';
import { SignalGenerator, SignalGeneratorClass } from '../signal-generators/types';
import { AnyAnalytics, Signal } from '../../types';
import { SignalsSettingsConfig } from './settings';
interface ISignals {
    start(analytics: AnyAnalytics): Promise<void>;
    stop(): void;
    clearStorage(): void;
    registerGenerator(generators: (SignalGeneratorClass | SignalGenerator)[]): Promise<void>;
}
export type SignalsPublicEmitterContract = {
    signal: [Signal];
};
export declare class Signals implements ISignals {
    private buffer;
    signalEmitter: SignalEmitter;
    private cleanup;
    private signalsClient;
    private globalSettings;
    constructor(settingsConfig?: SignalsSettingsConfig);
    /**
     * Does the following:
     * - Sends any queued signals to the server.
     * - Augments the analytics client to transform events -> signals
     * - Registers custom signal generators.
     */
    start(analytics: AnyAnalytics): Promise<void>;
    stop(): void;
    clearStorage(): void;
    /**
     * Emit custom signals.
     */
    registerGenerator(generators: (SignalGeneratorClass | SignalGenerator)[]): Promise<void>;
}
export {};
//# sourceMappingURL=signals.d.ts.map